require 'sketchup.rb'
#-----------------------------------------------------------------------------
def create_box1 
  
    @lenght1 = 6.feet if not @lenght1 # along Green Y axis
    @width1 =  5.feet if not @width1  # along Red  X axis
    @height1 = 2.feet if not @height1 # along Blue Z axis
    
    prompts = ["Lenght", "Width", "Height"]
    values = [@lenght1, @width1, @height1]
    results = inputbox prompts, values, "Box Red"
    return if not results
    @lenght1, @width1, @height1 = results
     
    model = Sketchup.active_model
    model.start_operation "Create Box"
#-----------------------------------------------------------------------------       
    new_comp_def = Sketchup.active_model.definitions.add
        
    @pt0 = [0, 0, 0]
    @pt1 = [0, @lenght1, 0]
    @pt2 = [0, @lenght1, @height1]
    @pt3 = [0, 0, @height1] 
       
    newface = new_comp_def.entities.add_face(@pt0, @pt1, @pt2, @pt3)
    newface.material=Sketchup::Color.new(255,0,0) #color red
    newface.material.alpha = 0.2 
    newface.pushpull @width1

    trans = Geom::Transformation.new 
    Sketchup.active_model.active_entities.add_instance(new_comp_def, trans) 

model.commit_operation
end
#-----------------------------------------------------------------------------
def create_box2 
  
    @lenght2 = 2.feet if not @lenght2 # along Green Y axis
    @width2 =  5.feet if not @width2  # along Red  X axis
    @height2 = 6.feet if not @height2 # along Blue Z axis
    
    prompts = ["Lenght", "Width", "Height"]
    values = [@lenght2, @width2, @height2 ]
    results = inputbox prompts, values, "Box Blue"
    return if not results
    @lenght2, @width2, @height2 = results
     
    model = Sketchup.active_model
    model.start_operation "Create Box"
#-----------------------------------------------------------------------------       
    entities = model.active_entities
    group = entities.add_group
    entities = group.entities 
        
    @pt0 = [0, 0, 0]
    @pt1 = [0, @lenght2, 0]
    @pt2 = [0, @lenght2, @height2]
    @pt3 = [0, 0, @height2] 
       
    newface = entities.add_face(@pt0, @pt1, @pt2, @pt3)
    newface.material=Sketchup::Color.new(0,0,128) #color blue
    newface.material.alpha = 0.2 
    newface.pushpull @width2

model.commit_operation
end
#-----------------------------------------------------------------------------
if( not file_loaded?("box0.rb") )
     utilities_menu = UI.menu("Plugins").add_submenu("Box Snippet")
        utilities_menu.add_item("Box - component") {  create_box1  }
        utilities_menu.add_item("Box - group") {  create_box2 }
end
#-----------------------------------------------------------------------------
file_loaded("box0.rb") # load"box0.rb"